﻿//Custom_Protocol_Schema: bo://

//SendToClient: 
//    {
//        "ActionName": "GoToSignIn",
//        "CallbackId": "",
//        "Data": {}
//    }

//CallbackFromClient: 
//    {
//        "CallbackId": "",
//        "TypeName": "ios",
//        "Data": {}
//    }

(function () {
    if (window.BOJSBridge) { return }

    var bridgeIframe,
        bridgeIframeId = "bridgeIframe",
        Custom_Protocol_Schema = "bo",
        uniqueId = 1,
        responseCallbacks = {};


    function _createIframe(doc) {
        if (bridgeIframe) { return; };

        bridgeIframe = doc.createElement('iframe');
        bridgeIframe.setAttribute("id", bridgeIframeId);
        bridgeIframe.style.display = "none";
        doc.documentElement.appendChild(bridgeIframe);
    }


    function _init(data, responseCallback) {
        _createIframe(window.document);
        if (typeof data != 'function') {

        } else {
            if (typeof responseCallback == 'undefined') {
                _sendToClient("Initilized", {}, data);
            } else if (typeof responseCallback == 'function') {
                _sendToClient("Initilized", data, responseCallback);
            }
        }
    }

    function _goToHome(data, responseCallback) {
        _sendToHomeClient("GoToHome", data, responseCallback);
    }


    function _sendToHomeClient(actionName, data, responseCallback) {
        if (!data) { data = {}; }

        var callbackId;
        if (responseCallback) {
            callbackId = 'cb_' + (uniqueId++) + '_' + new Date().getTime();
            responseCallbacks[callbackId] = responseCallback;
        }

        var parameters = {
            "ActionName": actionName,
            "CallbackId": callbackId,
            "Data": data
        };
        bridgeIframe.src = Custom_Protocol_Schema + '://' + encodeURIComponent(JSON.stringify(parameters));
    }

    function _sendToClient(actionName, data, responseCallback) {
        if (!data) { data = {}; }

        var callbackId;
        if (responseCallback) {
            callbackId = 'cb_' + (uniqueId++) + '_' + new Date().getTime();
            responseCallbacks[callbackId] = responseCallback;
        }

        var parameters = {
            "ActionName": actionName,
            "CallbackId": callbackId,
            "Data": data
        };
        bridgeIframe.src = Custom_Protocol_Schema + '://' + encodeURIComponent(JSON.stringify(parameters));
    }

    function _launchApp(actionName, data, responseCallback) {
        if (!data) { data = {}; }

        var callbackId;
        if (responseCallback) {
            callbackId = 'cb_' + (uniqueId++) + '_' + new Date().getTime();
            responseCallbacks[callbackId] = responseCallback;
        }

        var queryString = "?";
        for (var q in data) {
            if (queryString !== "?") {
                queryString += "&";
            }
            queryString += (q + "=" + data[q]);
        }

        bridgeIframe.src = 'ioffice100://register/' + actionName + queryString;
    }


    function _callbackFromClient(responseData) {
        var data = JSON.parse(responseData);
        if (data.CallbackId) {
            var responseCallback = responseCallbacks[data.CallbackId];
            if (!responseCallback) { return; }
            responseCallback(data.Data);
            delete responseCallbacks[data.CallbackId];
        }
    }

    window.BOJSBridge = {
        init: _init,
        goToHome: _goToHome,
        sendToClient: _sendToClient,
        callbackFromClient: _callbackFromClient
    };

})()
